# hebern5_tui.py 
# mai 2023: chiffrement (d'apres Friedman: OK)
#           avancement (d'apres Friedman: OK [jusqu'a 600]

import string
import sys
import getopt
from hebern5 import *
ALPHA = string.ascii_uppercase

# ===================================
def is_maj(car):
    if ALPHA.find(car) == -1:
        return False
    else:
        return True
# ==================================
def usage():
    print("usage:")
    print("Syntax: hebern5_tui.py [option...]")
    print("Example: ")
    print(" echo AAAA|python hebern5_tui.py -I 3:2:5:1:4 -E MEANING -c")
    print("Options:")
    print(" -h             Help")
    print(" -I internal    Internal Key (1:2:3:4:5) by default)")
    print(" -V verse       The Face of each rotor (00000 by default)")
    print(" -E external    Extenal Key (NZAZAZN by default")
    print("                which corresponds to effective key OAAAAAO)")
    print(" -c/-d          Cipher (by default)/Decipher")
    print(" -v/-D          Verbose (Debug)")
# ================================================
try:
  opts, args = getopt.getopt(sys.argv[1:],
    "hI:E:cdV:vD", ["help","internal=", "external=", "cipher", "decipher", 
    "verse=", "verbose", "debug" ])
except getopt.GetoptError as err:
  # print help information and exit:
  print(sys.argv[0],": ", str(err)) # option -a not recognized
  usage()
  sys.exit(2)

DEBUG = False
INTERNAL = ["1","2","3","4","5"]
VERSE = [0,0,0,0,0]
EXTERNAL = "NZAZAZN"
MODE = 0  # cipher

for o, a in opts:
  if   o in ("-v", "--verbose", "-D", "--debug"):
    DEBUG = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-I", "--internal"):
    INTERNAL = a.split(":")
  elif o in ("-V", "--verse"):
    VERSE = list(map(int,list(a)))
  elif o in ("-E", "--external="):
    EXTERNAL = a
  elif o in ("-c", "--cipher"):
    MODE = 0
  elif o in ("-d", "--decipher"):
    MODE = 1
  else:
    assert False, "unhandled option"

# ================================================
leTexte = sys.stdin.readlines()
clair = ""
n = 0
for i in range(len(leTexte)):
    ch = leTexte[i]
    ch = ch.upper()
    for j in range(len(ch)):
        if not is_maj(ch[j]):
            continue
        car = ch[j]
        clair += car
#print clair

h = Hebern5( intKey=INTERNAL, verse=VERSE, mode=MODE, debug=DEBUG)
h.mise_a_la_cle( EXTERNAL )
if DEBUG: print(h.info())
if DEBUG: print("Key: ", h.obtient_cle())
crypto = h.chiffre( clair )
print(crypto)

